#!/bin/sh

LEDMINOR=151
DEV=/dev/led
STR=char-major-10-$LEDMINOR
MOD=led
FILE=/etc/modprobe.conf

case "$1" in
  install)
    if ! grep $STR $FILE
    then echo "alias $STR $MOD" >> $FILE
    fi

    if [ ! -c $DEV ]
    then mknod $DEV c 10 $LEDMINOR
         chown root.root $DEV
         chmod 660 $DEV
    fi
  ;;
  uninstall)
    rm -f $DEV
    perl -i.bak -ne "print unless /$STR/" $FILE
  ;;
  *)
    echo 'usage: device.sh [install|uninstall]'
  ;;
esac
