#ifndef REGISTRY_HPP
#define REGISTRY_HPP

#include <windows.h>

#include <string>

struct RegistryError { };

class Registry
{
protected:
  HKEY hKey;

public:
  Registry(const std::string& subkey, const HKEY mainkey=HKEY_LOCAL_MACHINE, bool create=true);
  ~Registry();
  void set(const std::string& key, const std::string& val);
  void set(const std::string& key, const DWORD i);
  std::string getString(const std::string& key);
  DWORD getInt(const std::string& key);
  DWORD get(const std::string& key, BYTE *buf, DWORD& bufLen);
  void del(const std::string& key);
};

#endif
